	Program Torquemap

C	Task: make map (distance-planetmass) for the torque
C	Mai 2012, Bert

        implicit real*8 (a-h,o-y)

	CHARACTER input*72,inputname*52
	CHARACTER output*72,output2*72
	real*8 radius(0:10000)
	real*8 torque(0:10000)
	real*8 Height(0:10000)
	real*8 Sigma(0:10000)
	real*8 kappa(0:10000)
	real*8 Temp(0:10000)
	real*8 Rho(0:10000)
	real*8 Pres(0:10000)
	real*8 Fpnu(0:10000), pnu(0:10000), pxi(0:10000), OmegaP(0:10000), Fpxi(0:10000)
	real*8 Gpnu(0:10000), Gpxi(0:10000), Kpnu(0:10000), Kpxi(0:10000), GammaCENT(0:10000)
	real*8 GammaZero(0:10000), gammaeff(0:10000), Q(0:10000), Vchi(0:10000)
	real*8 GammaCBARO(0:10000), GammaLIN(0:10000),Corot(0:10000),Horse(0:10000)
	real*8 beta(0:10000), xi(0:10000), DeltaTemp(0:10000),alpha(0:10000),DeltaSigma(0:10000),DeltaPres(0:10000)
	real*8 GammaHSENT(0:10000), GammaCLINENT(0:10000), gamma, pi,massratio,nuplanet(0:10000)
	real*8 GammaLINvalue, GammaCLINBARO, GammaHSBARO,Mnormal,viscalph(0:10000),scaling,LP,metal,Growthtime
	real*8 eta,Mdot, stokes
        real*8 MASSRATIOMIN, MASSRATIOMAX, THICKNESSSMOOTHING
        integer NMASS, NRAD

	real*8 P_p(0:10000)
	real*8 Gam_iso3d_tot(0:10000),Gam_iso3d_lind(0:10000)
	real*8 Gam_rad3d(0:10000), Paar2010(0:10000)

C THINGS TO SET: massratio, epsh, npx, k loop index
        MASSRATIOMIN=0.005*3.0*10**(-6.0)     ! planet mass to start with, in fractions of the primary mass (1M_E = 3.0*10**(-6.0) M_SUN)
        MASSRATIOMAX=2*3.0*10**(-6.0) ! planet mass to end with
        NMASS=1000                     ! number of increments in the planetary mass axis
        THICKNESSSMOOTHING=0.4          ! smoothing parameter in the grav.pot. calculation, in fractions of local thickness
        NRAD=1024                       ! number of radial zones in the simulation

C	Definition of constants:
	gamma=1.4
	scaling=1.0
	pi=3.141592654
	massratio=MASSRATIOMIN
C	viscalph=0.00308*scaling
        epsh=THICKNESSSMOOTHING
        xmstar=1.0e0

**  constants from Nirvana
      XMSOL = 1.989 D+33  ! Solar Mass
      XMH   = 1.67  D-24  ! Hydrogen Mass
      AU    = 1.496 D+13  ! Astronomical Unit
      BOLTZ = 1.38  D-16  ! Boltzmann Constant
      CLIGHT= 2.998 D+10  ! Light speed
      GRAVC = 6.67  D-08  ! Gravitation Constant
      AR    = 7.56  D-15  ! Radiation Constant
      RGAS  = 8.314 D+07  ! Gas Constant
	sr=5.670d-5    ! Stefan Boltzmann 

        R0     = 5.2 * AU
        VOL0   = R0**3
        XM0    = XMSOL * XMSTAR
        RHO0   = XM0 / VOL0
        TIME0  = SQRT(VOL0 / GRAVC / (XMSTAR*XMSOL))
        V0     = R0 / TIME0
        OPAC0  = R0*R0 / XM0
        XNU0   = R0*V0
        TEMP0  = V0*V0 / RGAS
        P0     = RGAS * RHO0 * TEMP0
	xmue=2.35
        E0     = XM0 * R0**2 * TIME0**(-2)
        SLUM   = 1.0D+0 * TIME0 / E0
        year = 3600.*24.*365.24
	Mnormal=XMSOL*XMSTAR*massratio
        xnu0 = r0**2/time0

	npx=NRAD-1

C	Input file
        call get_command_argument (1, input)
	open(10,file=input,form='formatted')

	do i=0,npx
	 read(10,*) radius(i),Rho(i),Temp(i),Pres(i),kappa(i),Sigma(i),viscalph(i),Height(i)
C	 write(*,*) i,radius(i),Rho(i),Temp(i),Sigma(i),kappa(i)
	end do

C	Put data into cgs units where needed.
	do i=0,npx
	 Rho(i)=Rho(i)/scaling
	 Sigma(i)=Sigma(i)/scaling
	 radius(i)=radius(i)/5.2
	 Height(i)=Height(i)/5.2
C	 Pres(i)=Pres(i)*P0
C	 Temp(i)=Temp(i)
	 kappa(i)=kappa(i)*scaling
	end do
	
C	Calculate height of the disc
	do i=0,npx
C	 Height(i)=sqrt(Pres(i)/(Rho(i)/Rho0))/sqrt(1.0/radius(i)**3.0)
C	 Height2= sqrt(Temp(i)*radius(i)*R0*RGAS / (GRAVC*XMSOL*xmue))/radius(i)
	 nuplanet(i)=viscalph(i)*Height(i)*Height(i)*sqrt(1.0/radius(i)**3.0)
C	 kappa(i)=0.1*kappa(i)
c	 write(*,*) radius(i),Height(i),Height(i)/radius(i),nuplanet(i),Temp(i)
	end do

C	Calculate slope of Temperature from Temp(i)
	do i=2,npx
C	 DeltaTemp(i)= (1.0/( (log10(Temp(i))-log10(Temp(i-1)))/(log10(radius(i))-log10(radius(i-1))) ) 
C     &               + 1.0/( (log10(Temp(i+1))-log10(Temp(i)))/(log10(radius(i+1))-log10(radius(i))) ) )**(-1.0)
C	 DeltaTemp(i) = DeltaTemp(i) * 2.0
	 DeltaTemp(i) = (log10(Temp(i+1))-log10(Temp(i-1)))/(log10(radius(i+1))-log10(radius(i-1)))
     &                + (log10(Temp(i))-log10(Temp(i-2)))/(log10(radius(i))-log10(radius(i-2)))
     &                + (log10(Temp(i+2))-log10(Temp(i)))/(log10(radius(i+2))-log10(radius(i)))
     &                + (log10(Temp(i-1))-log10(Temp(i-3)))/(log10(radius(i-1))-log10(radius(i-3)))
     &                + (log10(Temp(i+3))-log10(Temp(i+1)))/(log10(radius(i+3))-log10(radius(i+1)))
	 DeltaTemp(i) = DeltaTemp(i)/5.0
	 DeltaSigma(i) = (log10(Sigma(i+1))-log10(Sigma(i-1)))/(log10(radius(i+1))-log10(radius(i-1)))
     &                + (log10(Sigma(i))-log10(Sigma(i-2)))/(log10(radius(i))-log10(radius(i-2)))
     &                + (log10(Sigma(i+2))-log10(Sigma(i)))/(log10(radius(i+2))-log10(radius(i)))
     &                + (log10(Sigma(i-1))-log10(Sigma(i-3)))/(log10(radius(i-1))-log10(radius(i-3)))
     &                + (log10(Sigma(i+3))-log10(Sigma(i+1)))/(log10(radius(i+3))-log10(radius(i+1)))
	 DeltaSigma(i) = DeltaSigma(i)/5.0
	 DeltaPres(i) = (log10(Pres(i+1))-log10(Pres(i-1)))/(log10(radius(i+1))-log10(radius(i-1)))
     &                + (log10(Pres(i))-log10(Pres(i-2)))/(log10(radius(i))-log10(radius(i-2)))
     &                + (log10(Pres(i+2))-log10(Pres(i)))/(log10(radius(i+2))-log10(radius(i)))
     &                + (log10(Pres(i-1))-log10(Pres(i-3)))/(log10(radius(i-1))-log10(radius(i-3)))
     &                + (log10(Pres(i+3))-log10(Pres(i+1)))/(log10(radius(i+3))-log10(radius(i+1)))
	 DeltaPres(i) = DeltaPres(i)/5.0
C	 write(*,*) radius(i), DeltaTemp(i)
	end do
	DeltaTemp(1)=DeltaTemp(2)
	DeltaTemp(npx-1)=DeltaTemp(npx-2)
	DeltaSigma(1)=DeltaSigma(2)
	DeltaSigma(npx-1)=DeltaSigma(npx-2)
	DeltaPres(1)=DeltaPres(2)
	DeltaPres(npx-1)=DeltaPres(npx-2)
	do i=0,npx
	 beta(i) = -DeltaTemp(i)
	 alpha(i) = -DeltaSigma(i)
C	 kappa(i) = 0.1 !constant kappa
C	 beta(i) = 1.5
	end do

C	do i=0,npx
C	 write(44,*) radius(i),alpha(i),beta(i),nuplanet(i),Height(i),DeltaPres(i)
C	end do




**  all in cgs  units

C	Precalculated OmegaP
	do i=0,npx
	 OmegaP(i)=sqrt(1.d0/(radius(i))**3.0) / time0
         p_p(i) = 2.*pi/omegap(i) / year    !  Planet orbit in yrs (for testing)
C	 precalculate xi
	 xi(i)=beta(i)-(gamma-1.0)*alpha(i)
	end do

C	make loop over masses
        dm = (MASSRATIOMAX - MASSRATIOMIN)/NMASS        ! get mass increment

	do k=0,NMASS

C	Calculate Vchi(i)
	do i=0,npx
	 Vchi(i) = 16.0d0 *gamma*(gamma-1.0) *sr*Temp(i)**4.0 
     &   / (3.0*kappa(i)*rho(i)**2.0 *(Height(i)*r0)**2 *OmegaP(i)**2) 
	end do

C	calculate Q
	do i=0,npx
	 Q(i)=2.d0*Vchi(i)/(3.d0*(Height(i)/radius(i))**3)/((radius(i)*r0)**2 *omegap(i))
	 gammaeff(i)=2.0*Q(i)*gamma/(gamma*Q(i)+0.5*sqrt(2*
     &   sqrt((gamma**2*Q(i)**2+1.0)**2-16*Q(i)**2*(gamma-1.0))+2*gamma**2*Q(i)**2-2))
	end do

C	Calculate functions F,G,K
	do i=0,npx
         h = height(i)/radius(i)  !  relative disk thickness
         xs = 1.11/gammaeff(i)**(0.25) * (0.4/epsh)**(-0.25) * sqrt(massratio/h) !  dimensionless in units of r_p
         ang_p = (radius(i)*r0)**2 * omegap(i)   !  spec. Ang.mom of planet
         pnu(i) = 2./3. * sqrt( (ang_p *xs**3)/(2.*pi*nuplanet(i)*xnu0) )
         pxi(i) = sqrt( (ang_p *xs**3)/(2.*pi*vchi(i)) )
	 Fpnu(i)=1.0/(1.0+(pnu(i)/1.3)**2.0)
	 Fpxi(i)=1.0/(1.0+(pxi(i)/1.3)**2.0)
	end do

	do i=0,npx
	 if ((pnu(i)).lt.(sqrt(8.0/(45.0*pi)))) then
	  Gpnu(i)=16.0/25.0*(45.0*pi/8.0)**(0.75)*pnu(i)**(1.5)
	 else
	  Gpnu(i)=1.0-9.0/25.0*(8.0/(45.0*pi))**(1.33333)*pnu(i)**(-8.0/3.0)
	 end if
	end do

	do i=0,npx
	 if ((pxi(i)).lt.(sqrt(8.0/(45.0*pi)))) then
	  Gpxi(i)=16.0/25.0*(45.0*pi/8.0)**(0.75)*pxi(i)**(1.5)
	 else
	  Gpxi(i)=1.0-9.0/25.0*(8.0/(45.0*pi))**(1.33333)*pxi(i)**(-8.0/3.0)
	 end if
	end do

	do i=0,npx
	 if ((pnu(i)).lt.(sqrt(28.0/(45.0*pi)))) then
	  Kpnu(i)=16.0/25.0*(45.0*pi/28.0)**(0.75)*pnu(i)**(1.5)
	 else
	  Kpnu(i)=1.0-9.0/25.0*(28.0/(45.0*pi))**(1.33333)*pnu(i)**(-8.0/3.0)
	 end if
	end do

	do i=0,npx
	 if ((pxi(i)).lt.(sqrt(28.0/(45.0*pi)))) then
	  Kpxi(i)=16.0/25.0*(45.0*pi/28.0)**(0.75)*pxi(i)**(1.5)
	 else
	  Kpxi(i)=1.0-9.0/25.0*(28.0/(45.0*pi))**(1.33333)*pxi(i)**(-8.0/3.0)
	 end if
	end do

	do i=0,npx
c	GammaHSENT(i)=7.9*xi(i)/gammaeff(i)
	GammaHSENT(i)=xi(i)/gammaeff(i)*(0.4/epsh)*(10.1*sqrt(0.4/epsh)-2.2)
	GammaCLINENT(i)=(2.2-1.4/gammaeff(i))*xi(i)
	end do


C 	calculate torque for paar2011
C	GammaZero in Units of r_P^2 Omega_P^2
	do i=0,npx
c	GammaLINvalue=-2.5-1.7*beta(i)+0.1*alpha(i)
	GammaLINvalue=-(2.5+1.7*beta(i)-0.1*alpha(i))*(0.4/epsh)**(0.71)
	GammaCLINBARO=0.7*(1.5-alpha(i))
c	GammaHSBARO=1.1*(1.5-alpha(i))
	GammaHSBARO=1.1*(0.4/epsh)*(1.5-alpha(i))

  	 GammaZero(i)=(massratio/(Height(i)/radius(i)))**2.0 * Sigma(i)* (radius(i)*r0)**4 * omegap(i)**2 
         xnorm = 1.0/ Mnormal / (r0**2/time0**2) 
         xfact = gammazero(i) * xnorm / gammaeff(i)
	 GammaLIN(i)=GammaLINvalue * xfact
	 GammaCBARO(i)=(GammaHSBARO*Fpnu(i)*Gpnu(i)+(1.0-Kpnu(i))*GammaCLINBARO) * xfact
	 GammaCENT(i)=( GammaHSENT(i)*Fpnu(i)*Fpxi(i)*sqrt(Gpnu(i)*Gpxi(i))
     &		+ sqrt((1.0-Kpnu(i))*(1.0-Kpxi(i)))*GammaCLINENT(i) ) * xfact
	 Corot(i)=((1.0-Kpnu(i))*GammaCLINBARO+sqrt((1.0-Kpnu(i))*(1.0-Kpxi(i)))*GammaCLINENT(i)) * xfact 
	 Horse(i)=(GammaHSBARO*Fpnu(i)*Gpnu(i)+GammaHSENT(i)*Fpnu(i)*Fpxi(i)*sqrt(Gpnu(i)*Gpxi(i))) * xfact
	end do

C 	Renormalize  3D  Nirvana Torques 
	do i=0,npx
         torq_0 = rho0*r0**3  * (r0/time0)**2   !  Dimensions of torque from Code  
         xnorm = 1.0/ Mnormal  / (r0**2/time0**2) 
         xfact = torq_0 * xnorm
         gam_rad3d(i) =  torque(i) * xfact
	end do

	output='massdataGamma0.out'
	OPEN(54,FILE=output,STATUS='UNKNOWN',FORM='FORMATTED')
	write(54,'(A)') '# r   mass   Lin   Baro    Cent   TotNorm  ToT(cgs)'
	do i=0,npx
         xnorm = 1.0/ Mnormal / (r0**2/time0**2) 
         xfact = gammazero(i) * xnorm / gammaeff(i) !Normalization factor to Gamma_0 as defined in Paardekooper 2011
	 write(54,'(7(1x,E10.4))') radius(i)*5.2, massratio, 
     &		GammaLIN(i)/xfact, GammaCBARO(i)/xfact, GammaCENT(i)/xfact,
     &          (GammaLIN(i)+GammaCBARO(i)+GammaCENT(i))/xfact,
     &          (GammaLIN(i)+GammaCBARO(i)+GammaCENT(i))/xnorm*gammaeff(i)
	end do
	write(54,*) ''

        massratio=massratio+dm
	Mnormal=XMSOL*XMSTAR*massratio
	end do !loop over mass





	End
